package com.nhnst.oc.sso.model;

import java.io.Serializable;
import java.util.LinkedHashMap;
import java.util.Map;

public class ReturnModel<T> implements Serializable {

	private static final long serialVersionUID = -5104765158650857698L;

	private ReturnHeader header = null;

	private Map<String, Object> result;

	public ReturnModel() {
		this.header = new ReturnHeader(true);
	}

	public ReturnModel(T data) {
		this.header = new ReturnHeader(true);
		if (result == null) {
			result = new LinkedHashMap<String, Object>();
		}

		result.put("content", data);
	}

	public ReturnHeader getHeader() {
		return this.header;
	}

	public void setHeader(ReturnHeader header) {
		this.header = header;
	}

	public Map<String, Object> getResult() {
		return result;
	}

	public void setResult(Map<String, Object> result) {
		this.result = result;
	}

}
