package com.nhnst.oc.sso.utils;

import java.nio.charset.StandardCharsets;

import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;

import org.apache.commons.codec.binary.Base64;

public class TokenUtil {
	// API key
	private static final String API_KEY = "0718d0c278714a99b1a444405ef03778";

	public static void main(String[] args) throws Exception {
		long timestamp = 1603689662879L;
		String token = generateToken(API_KEY, "T1575430372729Qx8Bq", timestamp);
		System.out.println(token);
	}

	public static String generateToken(String key, String contentJson, long timestamp) throws Exception {

		SecretKeySpec signingKey = new SecretKeySpec(key.getBytes(StandardCharsets.UTF_8), "HmacSHA256");
		Mac mac = Mac.getInstance(signingKey.getAlgorithm());
		mac.init(signingKey);
		String content = contentJson + "&" + timestamp;
		System.out.println("content: " + content);

		byte[] rawHmac = mac.doFinal(content.getBytes(StandardCharsets.UTF_8));
		String token = new String(Base64.encodeBase64(rawHmac));

		System.out.println("token: " + token);

		return token;
	}
}
