<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta name="viewport" content="width=device-width,initial-scale=1.0,minimum-scale=1.0,maximum-scale=1.0,user-scalable=0">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>Help Center</title>

<style type="text/css">
  li {height: 30px;}
</style>

<script type="text/javascript" src="/static/jquery/jquery-3.3.1.min.js"></script>
<script type="text/javascript">
	var domain="https://${domain}/hangame/hc/";
	
	function changeFrameSrc(uri) {
		var frame = document.getElementById('ocPage');
		frame.src = domain + uri; 
	}
	// get cookie
	function getCookie(name) {
	    var arr,reg=new RegExp("(^| )"+name+"=([^;]*)(;|$)");
	    if(arr=document.cookie.match(reg))
	        return unescape(arr[2]);
	    else
	        return null;
	}
	$.when( $.ready ).then(function() {
	    var ssotoken = getCookie("sso_test_login");
	    var usercode = getCookie("usercode");
	    if(ssotoken != null && usercode != null) {
	        var signout = $("#signout");
	        $("#signout").html("Welcome " + usercode + "! <a href='/logout.nhn'>Sign out</a>");
	        $("#signout").show();
	        $("#signin").hide();
	    }
	});

	// Listener for OC content height change
	window.addEventListener('message',function(event){
    	// Set iframe height
    	if(event.data > 0) {
    		updateHeight(event.data);
    	}
	});

	var updateHeight = function(wrapHeight) {
		var iframe = window.document.getElementById('ocPage');
		if(iframe != null) {
			iframe.style.height = '0px'; 
			var setHeight = (document.body.clientHeight > document.body.scrollHeight) ? document.body.clientHeight : document.body.scrollHeight;
			var margin = 70;
			setHeight = setHeight > wrapHeight ? setHeight : wrapHeight;
			iframe.style.height = setHeight + margin + "px";
		}
	};
</script>
</head>
<body>
  <div >
    <ul style="position: block; height: 100%;">
      <li><a href="javascript:changeFrameSrc('notice/');" target="_self" class="menu_txt">공지사항</a></li>
      <li><a href="javascript:changeFrameSrc('article/');" target="_self" class="menu_txt">FAQ</a></li>
      <li><a href="javascript:changeFrameSrc('ticket/');" target="_self" class="menu_txt">1:1 문의하기</a></li>
      <li><a href="javascript:changeFrameSrc('ticket/list/');" target="_self" class="menu_txt">문의내역</a></li>
      <li id="signout" style="display:none"></li>
      <li id="signin"><a href="/form/login.nhn?returnUrl=https%3a%2f%2fdev-chat-oc.toast.com:8081%2fhelp%2findex.nhn">Sign in</a></li>
    </ul> 
  </div>

  <div>
    <iframe src="https://${domain}/hangame/hc/?iframe=true" id="ocPage" frameborder="0" scrolling="no" 
      style="padding-top: 60px; box-sizing: unset; height: 100px; width: 100%"></iframe>
  </div>
</body>
</html>